VERSION 5.00
Begin VB.Form fTest 
   BackColor       =   &H8000000A&
   Caption         =   "Form1"
   ClientHeight    =   7485
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   12015
   LinkTopic       =   "Form1"
   ScaleHeight     =   7485
   ScaleWidth      =   12015
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Menu a 
      Caption         =   "a"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "fTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private MenuRootDS As cMenuItem         'define a (Root)-DataSource as cMenuItem
 
Private TopPanel As cWidgetForm, ToolPanel As cWidgetForm 'our two hWnd-based Panel-Stripes
Private WithEvents MenuBar As cwMenuBar 'define a MenuBar-Widget-Variable WithEvents as cwMenuBar
Attribute MenuBar.VB_VarHelpID = -1
Private WithEvents ToolBar As cwToolBar 'define a ToolBar-Widget-Variable WithEvents as cwToolBar
Attribute ToolBar.VB_VarHelpID = -1
Private WithEvents PopUp As cwMenu      'define a PopUp-Widget-Variable WithEvents as cwMenu
Attribute PopUp.VB_VarHelpID = -1
 
Private Sub Form_Load()
  ScaleMode = vbPixels
  'instantiate the DataSource from our JSON-String (not yet connected with the cwMenuBar-Widget)
  Set MenuRootDS = Cairo.CreateMenuItemFromJSON(ExampleMenuAsJSONString)
  
  Set TopPanel = Cairo.WidgetForms.CreateChild(hWnd)
  Set MenuBar = TopPanel.Widgets.Add(New cwMenuBar, "MenuBar", 0, 0, ScaleWidth, 25)
  Set MenuBar.DataSource = MenuRootDS 'here we connect the MenuBar to the cMenuItem-based DataSource-RootObject
  
  Set ToolPanel = Cairo.WidgetForms.CreateChild(hWnd)
  Set ToolBar = ToolPanel.Widgets.Add(New cwToolBar, "ToolBar", 0, 0, 1, 31)
      ToolBar.Widget.ToolTipDelay = 200 'a ToolTipDelay, somewhat shorter than the default
  CreateToolBarEntriesOn ToolBar
End Sub

Private Sub Form_Resize()
  TopPanel.Move 0, 0, ScaleWidth, MenuBar.Widget.Height
  ToolPanel.Move 0, MenuBar.Widget.Height, ScaleWidth, ToolBar.Widget.Height
End Sub

Private Sub MenuBar_Click(ByVal CurMenuItemPath As String)
Dim CurDSItem As cMenuItem

  Caption = CurMenuItemPath 'just to visualize the incoming Event-Parameter
  Set CurDSItem = MenuBar.DataSource.SubItemByPathKey(MenuBar.DataSource.Key & ">" & CurMenuItemPath)   'retrieve a concrete cMenuItem from a "Full-Path"
 
  Select Case CurMenuItemPath
    Case "File>Open":    New_c.FSO.ShowOpenDialog , App.Path, , , , , Me.hWnd
    Case "File>SaveAs":  New_c.FSO.ShowSaveDialog , App.Path, , , , , Me.hWnd
    Case "File>ExitApp": Unload Me
  
    Case "Extras>Item4" 'demonstrates, how to react to changes in the Checked-State
      '...of a certain MenuItem ... in this case "Item4" of our Extras-Menu
      MenuRootDS.SubItemByPathKey(MenuBar.DataSource.Key & ">" & "Extras>Item2").Enabled = Not CurDSItem.Checked
  End Select
End Sub

Private Sub PopUp_Click(ByVal CurMenuItemPath As String)
  Caption = CurMenuItemPath
End Sub

Private Sub ToolBar_Click(Sender As cwToolBarItem)
  Caption = "ToolBarItem-Click from: " & Sender.Widget.Key & IIf(Sender.IsCheckable, " (" & Sender.Checked & ")", "")
End Sub
 
Private Sub ToolBar_ArrowClick(Sender As cwToolBarItem)
Dim PopupRoot As cMenuItem
  Set PopupRoot = Cairo.CreateMenuItemRoot("PopUp", "PopUp")
  AddEditMenuEntriesTo PopupRoot
  
  Set PopUp = New cwMenu
      PopUp.InitAndShow Sender.Widget, PopupRoot, PopupBehaviourDropDownRightAligned
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  TopPanel.Unload
  ToolPanel.Unload
End Sub

Private Sub Form_Terminate()
  If Forms.Count = 0 Then New_c.CleanupRichClientDll
End Sub
