Attribute VB_Name = "modMain"
Option Explicit
 
Sub Main()
  AddImageResources
  
  fTest.Show
End Sub
 
Private Sub AddImageResources()
  'just 3 different example-icons for the Extras-MenuDef (see modMenuResources)
  Cairo.ImageList.AddIconFromResourceFile "MenuIconKey1", "shell32.dll", 322, 32, 32
  Cairo.ImageList.AddIconFromResourceFile "MenuIconKey2", "shell32.dll", 323, 32, 32
  Cairo.ImageList.AddIconFromResourceFile "MenuIconKey3", "shell32.dll", 311, 32, 32

  'for all other menu-icons we use mostly svg-based images (just to show that this is doable)
  AddImagesFromFolder New_c.FSO.GetDirList(App.Path & "\Res\Icons")
End Sub

Sub AddImagesFromFolder(DL As cDirList, Optional ByVal DesiredSize As Long = 32)
Dim i As Long, Key As String
 
  For i = 0 To DL.FilesCount - 1
    Key = Left$(DL.FileName(i), InStrRev(DL.FileName(i), ".") - 1)
    If InStr(1, New_c.FSO.GetFileExtension(DL.FileName(i)), "svg", vbTextCompare) Then
      Cairo.ImageList.AddImage Key, DL.Path & DL.FileName(i), DesiredSize, DesiredSize, True
    Else
      Cairo.ImageList.AddImage Key, DL.Path & DL.FileName(i)
    End If
  Next i
End Sub
